#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#define SIZE 8

int
main (int argc, char **argv)
{
  int desc, trans, i, j;
  unsigned char *data_read, *data_write;

  if (argc != 2)
    {
      fprintf (stderr, "hc08_user take one argument (device)\n");
      exit (-1);
    }
  data_read = (unsigned char *) malloc (SIZE * sizeof (unsigned char));
  data_write = (unsigned char *) malloc (SIZE * sizeof (unsigned char));
  memset (data_write, 0x00, SIZE);
/* open the hc08 device */
  if ((desc = open (argv[1], O_RDWR)) == -1)
    {
      perror ("open ()");
      exit (-1);
    }
/* read on the hc08 device */
  while (1)
    {
      /* trying to write... in hope of a reading */
      if ((trans = write (desc, data_write, SIZE)) < SIZE)
	{
	  fprintf (stderr, "only %d bytes written instead of %d\n", trans,
		   SIZE);
	  perror ("write ()");
	  exit - 1;
	}
      memset (data_read, 0x00, SIZE);
      if ((trans = read (desc, data_read, SIZE)) < SIZE)
	{
	  fprintf (stderr, "only %d bytes read instead of %d\n", trans, SIZE);
	  perror ("read ()");
	  exit - 1;
	}
      printf ("buffer : ");
      for (j = 0; j < SIZE; j++)
	{
	  printf ("%.2x ", data_read[j] & 0xff);
	}
      printf ("\n");
      if (data_write[5]>=0x90)
	{
	  data_write[4]=0x01;
	  data_write[5]=0x01;
	  data_write[6]=0x01;
	  data_write[7]=0x01;
	//  memset (data_write, 0x00, SIZE);
	}
      else
	{
//	  data_write[0]=0x80;
//	  data_write[1]=0x80;
//	  data_write[2]=0x80;
//	  data_write[3]=0x80;
//	  data_write[4]=0x61;
	  data_write[4]+=3;
	  data_write[5]+=3;
	  data_write[6]+=3;
	  data_write[7]+=3;
	}
      usleep (100000);

    }
  close (desc);
  return 0;
}
