; firmware for the MC68HC908JB8

; this firmware can be compiled with asl assembler

; this firmware listens the USB port and
; make 4 servo turns depending on the values
; received; the value 0 inhibits the servo

; 2 funcs have been erased ...
; all other useless have been comented

	cpu 68hc08
	relaxed on

	include jb8regs

	org	FLASHStart
__start:			; initialise
dc00:	ldhx	#$013f
dc03:	txs
dc04:	jsr	__HC08Setup
dc07:	ldhx	#$0041
dc0a:	bra	dc0f
dc0c:	clr	,x
dc0d:	aix	#$01
dc0f:	cphx	#$0075
dc12:	bne	dc0c
dc14:	ldhx	#$013f
dc17:	txs
dc18:	jsr	_main
_main_loop:			; main NOP loop
dc1b:	bra	_main_loop

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; USB sub routine called for EP0

dc1d:	ldhx	#UCR3
dc20:	lda	,x
dc21:	ora	#$30	; only keep STALLs flags
dc23:	sta	,x
dc24:	rts
dc25:	lda	$0049
; wait for 49 4b 4c and 4d to be zerro
dc28:	bne	dc39
dc2a:	lda	$004b
dc2d:	bne	dc39
dc2f:	lda	$004d
dc32:	bne	dc39
dc34:	lda	$004c
dc37:	beq	dc3b
dc39:	bra	dc1d

dc3b:	lda	$0046 ; when they are all zero :
dc3e:	cmp	#$02
dc40:	bne	dc39
dc42:	lda	$0048
dc45:	bne	dc39
dc47:	lda	$004a
dc4a:	cbeqa	#$81,	dc51
dc4d:	cmp	#$02
dc4f:	bne	dc39
dc51:	cmp	#$81
dc53:	bne	dc5e
dc55:	ldhx	#$003c
dc58:	lda	,x
dc59:	and	#$3f
dc5b:	sta	,x
dc5c:	bra	dc69
dc5e:	ldhx	#$0019
dc61:	lda	,x
dc62:	and	#$bf
dc64:	sta	,x
dc65:	clra
dc66:	sta	$0041
dc69:	lda	#$a0
dc6b:	sta	$3b
dc6d:	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

dc6e:	lda	$004b
dc71:	bne	dc8e	; branch if not zero
dc73:	lda	$004a
dc76:	bne	dc8e
dc78:	lda	$004d
dc7b:	bne	dc8e
dc7d:	lda	$004c
dc80:	bne	dc8e
dc82:	lda	$0049
dc85:	bne	dc8e
dc87:	lda	$0048
dc8a:	bit	#$80
dc8c:	beq	dc90

dc8e:	bra	dc1d

dc90:	lda	#$a0
dc92:	sta	$3b
dc94:	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

dc95:	lda	$004b
dc98:	bne	dcbc
dc9a:	lda	$004a
dc9d:	bne	dcbc
dc9f:	lda	$004d
dca2:	bne	dcbc
dca4:	lda	$004c
dca7:	bne	dcbc
dca9:	lda	$0049
dcac:	bne	dcbc
dcae:	lda	$0048
dcb1:	cmp	#$02
dcb3:	bcc	dcbc
dcb5:	lda	$0073
dcb8:	cmp	#$02
dcba:	bne	dcbf

dcbc:	jmp	dc1d

dcbf:	lda	$0048
dcc2:	beq	dcd3
dcc4:	lda	#$04
dcc6:	sta	$0073
dcc9:	lda	#$20
dccb:	sta	$3c
dccd:	lda	#$10
dccf:	sta	$19

dcd1:	bra	dcdc

dcd3:	lda	#$03
dcd5:	sta	$0073
dcd8:	clr	$3c
dcda:	clr	$19
dcdc:	lda	#$a0
dcde:	sta	$3b
dce0:	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

dce1:	ais	#-0x3
dce3:	lda	$0049
dce6:	cbeqa	#$01,	dcf4
dce9:	cbeqa	#$02,	dd02
dcec:	cbeqa	#$03,	dd10
dcef:	jsr	dc1d
dcf2:	bra	dd27

;;;;;;;;;;;;;;;;;;;;

dcf4:	ldx	#$e2
dcf6:	stx	$0043
dcf9:	lda	#$e0
dcfb:	sta	$0044
dcfe:	lda	#$12
dd00:	bra	dd24
dd02:	ldx	#$e2
dd04:	stx	$0043
dd07:	lda	#$f2
dd09:	sta	$0044
dd0c:	lda	#$20
dd0e:	bra	dd24
dd10:	ldx	$0048
dd13:	aslx
dd14:	clrh
dd15:	lda	$e36c,x
dd18:	sta	$0043
dd1b:	ldx	$e36d,x
dd1e:	stx	$0044
dd21:	psha
dd22:	pulh
dd23:	lda	,x
dd24:	sta	$0045

dd27:	lda	$0049
dd2a:	cbeqa	#$01,	dd34
dd2d:	cbeqa	#$02,	dd34
dd30:	cmp	#$03
dd32:	bne	dd91
dd34:	lda	$004c
dd37:	cmp	$0045
dd3a:	bcc	dd47
dd3c:	lda	$004d
dd3f:	bne	dd47
dd41:	lda	$004c
dd44:	sta	$0045
dd47:	tsx
dd48:	clr	,x
dd49:	lda	#$20
dd4b:	sta	$02,x
dd4d:	clr	$01,x
dd4f:	bra	dd78
dd51:	lda	$0043
dd54:	ldx	$0044
dd57:	psha
dd58:	pulh
dd59:	lda	,x
dd5a:	tsx
dd5b:	ldx	$01,x
dd5d:	pshx
dd5e:	ldx	$04,SP
dd61:	pulh
dd62:	sta	,x
dd63:	tsx
dd64:	inc	$02,x
dd66:	bne	dd6a
dd68:	inc	$01,x
dd6a:	ldhx	#$0043
dd6d:	inc	$01,x
dd6f:	bne	dd72
dd71:	inc	,x
dd72:	ldhx	#$0045
dd75:	dec	,x
dd76:	tsx
dd77:	inc	,x
dd78:	lda	$0045
dd7b:	beq	dd82
dd7d:	lda	,x
dd7e:	cmp	#$08
dd80:	bcs	dd51
dd82:	lda	,x
dd83:	add	#$a0
dd85:	sta	$3b
dd87:	lda	,x
dd88:	cmp	#$08
dd8a:	bcc	dd91
dd8c:	lda	#$ff
dd8e:	sta	$0047
dd91:	ais	#$03
dd93:	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; SETUP TOKEN FOR ENDPOINT 0 - RECEIVE

dd94:	ldhx	#$003b
dd97:	lda	,x
dd98:	and	#$ef
dd9a:	sta	,x
dd9b:	lda	#$01
dd9d:	sta	$18
dd9f:	clrh
dda0:	ldx	#$08
dda2:	lda	$1f,x
dda4:	sta	$0045,x
dda7:	dbnzx	dda2
dda9:	lda	$3d
ddab:	cbeqa	#$48,	ddb3
ddae:	jsr	dc1d
ddb1:	bra	ddd6
ddb3:	lda	$0046
ddb6:	bit	#$60
ddb8:	beq	ddbf
ddba:	jsr	dc1d
ddbd:	bra	ddd6
ddbf:	lda	$0047
ddc2:	cbeqa	#$01,	ddd3
ddc5:	cbeqa	#$05,	ddde
ddc8:	cbeqa	#$06,	dde3
ddcb:	cbeqa	#$09,	dde8
ddce:	jsr	dc1d
ddd1:	bra	ddd6
ddd3:	jsr	dc25
ddd6:	ldhx	#$003b
ddd9:	lda	,x
ddda:	ora	#$10
dddc:	sta	,x
dddd:	rts

;;;;;;;;;;;;;;;;;;;;;;

ddde:	jsr	dc6e
dde1:	bra	ddd6
dde3:	jsr	dce1
dde6:	bra	ddd6
dde8:	jsr	dc95
ddeb:	bra	ddd6

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; PAQUET FOR END POINT 0 WAS NOT A PAQUET TOKEN

dded:	ldhx	#UCR0
ddf0:	lda	,x
ddf1:	and	#$cf
ddf3:	sta	,x
ddf4:	lda	#$01
ddf6:	sta	UIR2
ddf8:	lda	,x
ddf9:	ora	#$10
ddfb:	sta	,x
ddfc:	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; TRANSMIT PAQUET EP0 FLAG is set ... 

ddfd:
	ais	#-0x03
ddff:	ldhx	#$003b
de02:	lda	,x
de03:	and	#$df
de05:	sta	,x
de06:	lda	#$02
de08:	sta	$18
de0a:	lda	$0047
de0d:	cmp	#$01
de0f:	beq	de85
de11:	cbeqa	#$05,	de23
de14:	cbeqa	#$06,	de3a
de17:	cmp	#$09
de19:	beq	de85
de1b:	inca
de1c:	beq	de8a
de1e:	jsr	dc1d
de21:	bra	de8a
de23:	lda	$0048
de26:	ora	#$80
de28:	sta	$38
de2a:	lda	$0048
de2d:	beq	de33
de2f:	lda	#$03
de31:	bra	de35
de33:	lda	#$02
de35:	sta	$0073
de38:	bra	de85
de3a:	tsx
de3b:	clr	,x
de3c:	lda	#$20
de3e:	sta	$02,x
de40:	clr	$01,x
de42:	bra	de6b
de44:	lda	$0043
de47:	ldx	$0044
de4a:	psha
de4b:	pulh
de4c:	lda	,x
de4d:	tsx
de4e:	ldx	$01,x
de50:	pshx
de51:	ldx	$04, SP
de54:	pulh
de55:	sta	,x
de56:	tsx
de57:	inc	$02,x
de59:	bne	de5d
de5b:	inc	$01,x
de5d:	ldhx	#$0043
de60:	inc	$01,x
de62:	bne	de65
de64:	inc	,x
de65:	ldhx	#$0045
de68:	dec	,x
de69:	tsx
de6a:	inc	,x
de6b:	lda	$0045
de6e:	beq	de75
de70:	lda	,x
de71:	cmp	#$08
de73:	bcs	de44
de75:	lda	$3b
de77:	eor	#$80
de79:	and	#$80
de7b:	add	,x
de7c:	add	#$30
de7e:	sta	$3b
de80:	lda	,x
de81:	cmp	#$08
de83:	bcc	de8a
de85:	lda	#$ff
de87:	sta	$0047
de8a:	ais	#$03
de8c:	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Transmit EP1 request ...

de8d:
	ais	#-0x03
de8f:	ldhx	#$003c
de92:	lda	,x
de93:	and	#$df
de95:	sta	,x
de96:	lda	#$08
de98:	sta	$18
de9a:	tsx
de9b:	clr	,x
de9c:	lda	#$28
de9e:	sta	$02,x
dea0:	clr	$01,x
dea2:	bra	dec5
dea4:	ldx	$0062
dea7:	clrh
dea8:	lda	$0063,x
deab:	tsx
deac:	ldx	$01,x
deae:	pshx
deaf:	ldx	$04, SP
deb2:	pulh
deb3:	sta	,x
deb4:	lda	$0062
deb7:	inca
deb8:	and	#$0f
deba:	sta	$0062
debd:	tsx
debe:	inc	$02,x
dec0:	bne	dec4
dec2:	inc	$01,x
dec4:	inc	,x
dec5:	lda	$0062
dec8:	cmp	$0061
decb:	beq	ded2
decd:	lda	,x
dece:	cmp	#$08
ded0:	bcs	dea4
ded2:	lda	$3c
ded4:	eor	#$80
ded6:	and	#$80
ded8:	add	,x
ded9:	add	#$20
dedb:	sta	$3c
dedd:	ais	#$03
dedf:	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Receive EP2  request ...

dee0:
	ais	#-0x04
dee2:	ldhx	#UCR2
dee5:	lda	,x
dee6:	and	#$ef
; warn Paquet cant be received on EP2
dee8:	sta	,x
dee9:	lda	#$10
deeb:	sta	UIR2	; 0x18<-#0x10 : clear RXD2F
deed:	lda	#$30
deef:	tsx
def0:	sta	$03,x
def2:	clr	$02,x
def4:	lda	USR1
def6:	and	#$0f ; lengh of paquet -> (SP+1)
def8:	sta	$01,x
defa:	bra	df24

defc:	lda	$004f
deff:	inca
df00:	and	#$0f
df02:	sta	,x	; (0x4f)+1 -> (SP)
df03:	cmp	$0050
df06:	beq	df03
df08:	tsx
df09:	lda	$02,x
df0b:	ldx	$03,x
df0d:	psha
df0e:	pulh
df0f:	lda	,x
df10:	ldx	$004f
df13:	clrh
df14:	sta	$0051,x
df17:	tsx
df18:	lda	,x
df19:	sta	$004f
df1c:	inc	$03,x
df1e:	bne	df22
df20:	inc	$02,x
df22:	dec	$01,x

df24:	tst	$01,x
df26:	bne	defc
df28:	lda	#$10
df2a:	sta	UCR2	; allow paquets to come on EP2
df2c:	ais	#$04	; restore SP
df2e:	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Init USB ;;;;;;;;;;;;

_initUSB
df2f:	lda	#$80
df31:	sta	$38
df33:	clr	$3b
df35:	clr	$3c
df37:	clr	$19
df39:	lda	#$44
df3b:	sta	$1a
df3d:	clr	$1b
df3f:	clr	$39
df41:	lda	#$ff
df43:	sta	$18
df45:	clra
df46:	sta	$0042
df49:	sta	$0041
df4c:	inca
df4d:	sta	$0073
df50:	clra
df51:	sta	$0062
df54:	sta	$0061
df57:	sta	$0050
df5a:	sta	$004f
df5d:	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; GetPipe()

df5e:	psha
df5f:	lda	$0050
df62:	cmp	$004f
df65:	beq	df5f
df67:	ldx	$0050
df6a:	clrh
df6b:	lda	$0051,x
df6e:	tsx
df6f:	sta	,x
df70:	lda	$0050
df73:	inca
df74:	and	#$0f
df76:	sta	$0050
df79:	lda	,x
df7a:	pulh
df7b:	rts
df7c:	psha
df7d:	pshx
df7e:	psha
df7f:	lda	$0061
df82:	inca
df83:	and	#$0f
df85:	tsx
df86:	sta	,x
df87:	cmp	$0062
df8a:	beq	df87
df8c:	lda	$02,x
df8e:	ldx	$0061
df91:	clrh
df92:	sta	$0063,x
df95:	tsx
df96:	lda	,x
df97:	sta	$0061
df9a:	ais	#$03
df9c:	rts

;;;;;;;;;;;;;;;;; Isr USB ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

_isrUSB:
df9d:	pshh
df9e:	lda	$40
dfa0:	psha
dfa1:	brclr7	UIR1,	dfae
; detect EOP - no paquet -> exit
dfa4:	clra
dfa5:	sta	$004e
dfa8:	lda	#$80
dfaa:	sta	UIR2	; clear EOPF
dfac:	bra	_exit_isr_usb

; detect if paquet is for EP0
dfae:	brclr0	UIR1,	dfbe 
; detect RXD0F - no paquet for EP0 -> 
dfb1:	brclr6	USR0,	dfb9 ; detect Setup token
dfb4:	jsr	dd94		; Setup Token ->
dfb7:	bra	_exit_isr_usb
dfb9:	jsr	dded	
; Paquet was not a Setup Token ->
dfbc:	bra	_exit_isr_usb
; paquet is not EP0 receive ...
dfbe:	brclr1	UIR1,	dfc6 ; detect transmit flag EP0
dfc1:	jsr	ddfd		; paquet is transmit ...
dfc4:	bra	_exit_isr_usb

; is paquet for EP1 ?
dfc6:	brclr3	UIR1,	dfce	; test Transmit EP1 Flag
dfc9:	jsr	de8d
dfcc:	bra	_exit_isr_usb

; paquet is thus for EP2 ...
dfce:	brclr4	UIR1,	dfd6	
; receive paquet EP2 Flag ?
dfd1:	jsr	dee0
dfd4:	bra	_exit_isr_usb

; should be transmit EP2 then ... no
; ... it is just ignored :/
dfd6:	brclr6	UIR1,	_exit_isr_usb	; is reset ?
dfd9:	jsr	_initUSB	; USB RESET request 
dfdc:	ldhx	#$001a
dfdf:	lda	,x
dfe0:	ora	#$03
dfe2:	sta	,x
dfe3:	lda	#$9b
dfe5:	sta	$39
dfe7:	ldhx	#$003b
dfea:	lda	,x
dfeb:	ora	#$10
dfed:	sta	,x
dfee:	lda	#$02
dff0:	sta	$0073

_exit_isr_usb:
dff3:	pula
dff4:	sta	$40
dff6:	pulh
dff7:	rti

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;(0052)Things that should be done immediately after Reset
;(0053)(this is called by the C-Startup Module)
;(0056) CONFIG = 0x21;  // USB Reset Disable, COP Disable
;(0057) TSC    = 0x00;  // clear TSTOP, Prescaler=0

__HC08Setup:
dff8:	lda	#$21
dffa:	sta	CONFIG
dffc:	clr	TSC
dffe:	rts

;;;;;;;;;;;;;;;;;;;;;;;;;; Dummy isr ;;;;;;;;;;;;;;;;;;;;

_isrDummy:
dfff:	nop
e000:	rti

;;;;;;;;;;;;;;;;;;;;;;;;;;; init_tim ;;;;;;;;;;;;;;;;;;;

_init_tim:
	mov	#0xF0, DDRA	; set PART A as out
	mov	#0x00, PTA
	bset6	TSC	; enable TIM overflow interrupt
	bset2	TSC	; write 0x05 to TSC -> 
	bclr1	TSC	; TIM clock source =
	bset0	TSC	; internal clock / 32

	bset4	TSC	; reset the TIM
	mov	#$07, TMODH
	; write 0x753 to the modulo register
	mov	#$53, TMODL
	; what sould produce n interrupt every 20ms
	bclr5	TSC	; release the TIM
	mov	#$0, servo_init
	mov	#$0, servo_0
	mov	#$0, servo_1
	mov	#$0, servo_2
	mov	#$0, servo_3
	mov	#$0, servo_4
	mov	#$0, servo_5
	mov	#$0, servo_6
	mov	#$0, servo_7
	rts

;;;;;;;;;; isr_timOverFlow ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

_isr_timOF:
	pshh
	brclr7	TSC, _isr_tim_exit
; clear interupt:
	lda	TSC
	bclr7	TSC
; ????????? I dont know why,
; but initialisation has to be done here ...

; toggle LED -> 25Hz
;	brset	2,PTD,_led_clr
;	bset2	PTD
;	bra	_isr_tim_cont
;_led_clr:
;	bclr2	PTD
;_isr_tim_cont:

; only take care of 4 servos here ...
; but this part can be extended
; to 8 servos as long as the designer
; of the board freed lower pins

	bset4	PTA
	bset5	PTA
	bset6	PTA
	bset7	PTA

; high state sleep : about 1ms
	lda	#$4
_plop_	jsr	_isr_tim_delay2
	dbnza	_plop_

; transfert global vlues to local tmp
	mov	servo_0,s0_tmp
	mov	servo_1,s1_tmp
	mov	servo_2,s2_tmp
	mov	servo_3,s3_tmp
	mov	servo_4,s4_tmp
	mov	servo_5,s5_tmp
	mov	servo_6,s6_tmp
	mov	servo_7,s7_tmp
;	lda	servo_4
;	sta	$4,x
;	lda	servo_4
;	sta	$5,x
;	lda	servo_4
;	sta	$6,x
;	lda	servo_4
;	sta	$7,x

	lda	#$FF	; loop 255 times
_isr_tim_loop:
	dec	s4_tmp	; 4c
	bne	_s4_end	; 3c
	bclr4	PTA	; 4c
_s4_end:
	dec	s5_tmp
	bne	_s5_end
	bclr5	PTA
_s5_end
	dec	s6_tmp
	bne	_s6_end
	bclr6	PTA
_s6_end
	dec	s7_tmp
	bne	_s7_end
	bclr7	PTA
_s7_end
;	nop	; to calibrate
;	jsr	_isr_tim_delay1
	dbnza	_isr_tim_loop

_isr_tim_exit:
	pulh
	rti

;;;;	short delay

_isr_tim_delay1
	psha
	lda	#0x5
_paf_		; 3 cycles = 1 us * 
	dbnza	_paf_
	pula
	rts

;;;;	long delay , about 250 us

_isr_tim_delay2
	psha
	lda	#0x80
_pof_		; 1 us per loop
	dbnza	_pof_
	pula
	rts

;;;;;;;;;;;;;;;;;;; main ;;;;;;;;;;;;;;;;;;;;;;;;;;;

_main:	; a is SP+9 , n is SP+8
e001:	ais	#-0x0c
e003:	jsr	_initUSB

; init LEDs
e006:	lda	#$ff
e008:	sta	$03
e00a:	ldhx	#$0007
e00d:	lda	#$07
e00f:	ora	,x
e010:	sta	,x

;e011:	jsr	_init_kbd
;e014:	jsr	_init_sensor	;
; set pullup for E:2-0 ; ADC
	jsr	_init_tim
e017:	cli

e018:	tsx
e019:	clr	$09,x	; a=0

; while(1) {
e01b:	aix	#$0a	; X+=0x0A
e01d:	txa		; A=X
e01e:	add	$0a, SP
e021:	tax

e022:	bcc	e029

e024:	pshh
e025:	inc	$01, SP
e028:	pulh

e029:	pshx
e02a:	pshh
e02b:	tsx
e02c:	lda	$0b,x
e02e:	clrx
e02f:	inca
e030:	bne	e033
e032:	incx
e033:
;	jsr	e199	; adc[a] = getSADC(a+1);
e036:	pulh
e037:	pulx

e038:	sta	,x
e039:	tsx
e03a:	inc	$09,x	; ++a
e03c:	lda	$09,x
e03e:	cmp	#$03	; if (a==3)
e040:	bne	e044
e042:	clr	$09,x	; then a=0

e044:	clra
e045:	sta	$08,x	; n=0
; do { io_buffer[n++] = getPipe();
e047:	inc	$08,x
e049:	stx	$40
e04b:	add	$40
e04d:	tax
e04e:	bcc	e055
e050:	pshh
e051:	inc	$01, SP
e054:	pulh

e055:	pshx
e056:	pshh
e057:	jsr	df5e	; GetPipe()
e05a:	pulh
e05b:	pulx
e05c:	sta	,x
e05d:	tsx
; }
e05e:	lda	$08,x
e060:	cmp	#$08	; while(n<8)
e062:	bcs	e047

	brset	0,servo_init,_servo_buf
	lda	$00,x
	bne	_servo_end
	lda	$01,x
	bne	_servo_end
	lda	$02,x
	bne	_servo_end
	lda	$03,x
	bne	_servo_end
	lda	$04,x
	bne	_servo_end
	lda	$05,x
	bne	_servo_end
	lda	$06,x
	bne	_servo_end
	lda	$07,x
	bne	_servo_end
	mov	#$FF,servo_init
_servo_buf
; transfert buf[] to servo_*
	lda	$00,x
	sta	servo_0
	lda	$01,x
	sta	servo_1
	lda	$02,x
	sta	servo_2
	lda	$03,x
	sta	servo_3
	lda	$04,x
	sta	servo_4
	lda	$05,x
	sta	servo_5
	lda	$06,x
	sta	servo_6
	lda	$07,x
	sta	servo_7
_servo_end
; switch the LEDs
; if(buf[0]==0) then OFF(LED1) else ON(LED1)
e064:	tst	,x
e065:	bne	e06f
e067:	ldhx	#$0003
e06a:	lda	,x
e06b:	ora	#$01
e06d:	bra	e075
e06f:	ldhx	#$0003
e072:	lda	,x
e073:	and	#$fe
e075:	sta	,x
e076:	tsx

; if(buf[1]==0) then OFF(LED2) else ON(LED2)
e077:	tst	$01,x
e079:	bne	e083
e07b:	ldhx	#$0003
e07e:	lda	,x
e07f:	ora	#$02
e081:	bra	e089
e083:	ldhx	#$0003
e086:	lda	,x
e087:	and	#$fd
e089:	sta	,x
e08a:	tsx

	bra	e09e
; free 3rd LED so that it can be used for tests ...
; if(buf[2]==0) then OFF(LED3) else ON(LED3)
;e08b:	tst	$02,x
;e08d:	bne	e097
;e08f:	ldhx	#$0003
;e092:	lda	,x
;e093:	ora	#$04
;e095:	bra	e09d
;e097:	ldhx	#$0003
;e09a:	lda	,x
;e09b:	and	#$fb
;e09d:	sta	,x

e09e:	clrx
e09f:	lda	#$01
;e0a1:	jsr	e10a	; getKey
e0a4:	tsx
e0a5:	sta	,x

;e0a6:	clrx
;e0a7:	lda	#$02
;e0a9:	jsr	e10a
;e0ac:	tsx
;e0ad:	sta	$01,x

;e0af:	clrx
;e0b0:	lda	#$03
;e0b2:	jsr	e10a
;e0b5:	tsx
;e0b6:	sta	$02,x

; added part to get NULL buf:
	lda	#0x55
	sta	$0,x
	lda	#0x66
	sta	$1,x
	lda	#0x77
	sta	$2,x

; buf[3-5]=adc[0-2]
;e0b8:	lda	$0a,x
;e0ba:	sta	$03,x
;e0bc:	lda	$0b,x
;e0be:	sta	$04,x
;e0c0:	lda	$0c,x
;e0c2:	sta	$05,x

; added part to get NULL buf:
	lda	#0xAA
	sta	$3,x
	lda	#0xBB
	sta	$4,x
	lda	#0xCC
	sta	$5,x

e0c4:	clra
e0c5:	sta	$08,x	; n=0
; do { putPipe(io_buffer[n++])
e0c7:	inc	$08,x
e0c9:	stx	$40
e0cb:	add	$40
e0cd:	tax
e0ce:	bcc	e0d5
e0d0:	pshh
e0d1:	inc	$01, SP
e0d4:	pulh
e0d5:	lda	,x
e0d6:	clrx
e0d7:	jsr	df7c
e0da:	tsx
; }
e0db:	lda	$08,x
e0dd:	cmp	#$08	; while(n<8)
e0df:	bcs	e0c7
e0e1:	jmp	e01b

; }

;;;;;;;;;;;;;;;; ????? ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; getKey

;e10a:	psha
;e10b:	pshx
;e10c:	lda	#$03
;e10e:	tsx
;e10f:	add	$01,x
;e111:	sta	$01,x
;e113:	lda	#$01
;e115:	ldx	$01,x
;e117:	beq	e11c
;e119:	lsla
;e11a:	dbnzx	e119
;e11c:	and	$0074
;e11f:	beq	e123
;e121:	lda	#$01
;e123:	ais	#$02
;e125:	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;dependency of getSADC()

;e13f:	psha
;e140:	pshx
;e141:	ais	#-0x03
;e143:	tsx
;e144:	clr	,x
;e145:	lda	$07,x
;e147:	bit	#$80
;e149:	bne	e151
;e14b:	asl	$08,x
;e14d:	rol	$07,x
;e14f:	bra	e155
;e151:	lsr	$03,x
;e153:	ror	$04,x
;e155:	inc	,x
;e156:	lda	,x
;e157:	cmp	#$08
;e159:	bcs	e145
;e15b:	lda	$08,x
;e15d:	ldx	$07,x
;e15f:	stx	$40
;e161:	ldx	$04, SP
;e164:	pshx
;e165:	ldx	$06, SP
;e168:	pulh
;e169:	jsr	e28a
;e16c:	clrh
;e16d:	ldx	#$87
;e16f:	jsr	e267
;e172:	tsx
;e173:	sta	$02,x
;e175:	lda	$40
;e177:	sta	$01,x
;e179:	lda	#$07
;e17b:	lsr	$01,x
;e17d:	ror	$02,x
;e17f:	dbnza	e17b
;e181:	lda	$01,x
;e183:	cmp	#$01
;e185:	bcs	e18d
;e187:	lda	#$ff
;e189:	sta	$02,x
;e18b:	clr	$01,x
;e18d:	lda	$02,x
;e18f:	ldx	$01,x
;e191:	ais	#$05
;e193:	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ???

;e194:	lda	#$f0
;e196:	dbnza	e196
;e198:	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; getSADC()

;e199:	psha
;e19a:	pshx
;e19b:	ais	#-0x10
;e19d:	cmp	#$03
;e19f:	bne	e1a4
;e1a1:	tsx
;e1a2:	inc	$11,x
;e1a4:	ldhx	#$0003
;e1a7:	lda	,x
;e1a8:	and	#$87
;e1aa:	sta	,x
;e1ab:	ldhx	#$0008
;e1ae:	lda	,x
;e1af:	ora	#$07
;e1b1:	sta	,x
;e1b2:	ldhx	#$0007
;e1b5:	lda	,x
;e1b6:	ora	#$78
;e1b8:	sta	,x
;e1b9:	ldhx	#$0009
;e1bc:	lda	,x
;e1bd:	ora	#$07
;e1bf:	sta	,x
;e1c0:	bsr	e194
;e1c2:	ldhx	#$0009
;e1c5:	lda	,x
;e1c6:	and	#$f8
;e1c8:	sta	,x
;e1c9:	ldx	$0c
;e1cb:	clr	$02, SP
;e1ce:	stx	$01, SP
;e1d1:	lda	$0d
;e1d3:	tsx
;e1d4:	add	$01,x
;e1d6:	sta	$09,x
;e1d8:	clra
;e1d9:	adc	,x
;e1da:	sta	$08,x
;e1dc:	lda	$08
;e1de:	and	$11,x
;e1e0:	bne	e1dc
;e1e2:	lda	$0c
;e1e4:	sta	$0a,x
;e1e6:	lda	$0d
;e1e8:	sta	$0b,x
;e1ea:	sub	$09,x
;e1ec:	sta	$03,x
;e1ee:	lda	$0a,x
;e1f0:	sbc	$08,x
;e1f2:	sta	$02,x
;e1f4:	ldhx	#$0007
;e1f7:	lda	,x
;e1f8:	and	#$c7
;e1fa:	sta	,x
;e1fb:	ldhx	#$0009
;e1fe:	lda	,x
;e1ff:	ora	#$07
;e201:	sta	,x
;e202:	bsr	e194
;e204:	ldhx	#$0009
;e207:	lda	,x
;e208:	and	#$f8
;e20a:	sta	,x
;e20b:	lda	$0c
;e20d:	tsx
;e20e:	sta	$0c,x
;e210:	lda	$0d
;e212:	sta	$0d,x
;e214:	lda	$08
;e216:	and	$11,x
;e218:	bne	e214
;e21a:	lda	$0c
;e21c:	sta	$0e,x
;e21e:	lda	$0d
;e220:	sta	$0f,x
;e222:	sub	$0d,x
;e224:	sta	$07,x
;e226:	lda	$0e,x
;e228:	sbc	$0c,x
;e22a:	sta	$06,x
;e22c:	lda	$03,x
;e22e:	sub	$07,x
;e230:	lda	$02,x
;e232:	sbc	$06,x
;e234:	bcs	e23a
;e236:	clrx
;e237:	clra
;e238:	bra	e253
;e23a:	lda	$07,x
;e23c:	sub	$03,x
;e23e:	sta	$05,x
;e240:	lda	$06,x
;e242:	sbc	$02,x
;e244:	sta	$04,x
;e246:	lda	$05,x
;e248:	sub	$03,x
;e24a:	lda	$04,x
;e24c:	sbc	$02,x
;e24e:	bcs	e256
;e250:	clrx
;e251:	lda	#$ff
;e253:	ais	#$12
;e255:	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;dependency of getSADC()

;e256:	lda	$05,x
;e258:	psha
;e259:	lda	$04,x
;e25b:	psha
;e25c:	lda	$03,x
;e25e:	ldx	$02,x
;e260:	jsr	e13f
;e263:	ais	#$02
;e265:	bra	e253
;e267:	pshx
;e268:	psha
;e269:	lda	$40
;e26b:	mul
;e26c:	sta	$40
;e26e:	pshh
;e26f:	pulx
;e270:	pula
;e271:	psha
;e272:	mul
;e273:	add	$40
;e275:	sta	$40
;e277:	pula
;e278:	pulx
;e279:	mul
;e27a:	psha
;e27b:	txa
;e27c:	add	$40
;e27e:	sta	$40
;e280:	pula
;e281:	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;e282:	bsr	e28a
;e284:	pshh
;e285:	pula
;e286:	sta	$40
;e288:	txa
;e289:	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ???

;e28a:	psha
;e28b:	pshh
;e28c:	tst	$01, SP
;e28f:	bne	e2ac
;e291:	pulh
;e292:	cpx	$40
;e294:	bls	e2a2
;e296:	lda	$40
;e298:	psha
;e299:	pulh
;e29a:	pula
;e29b:	div
;e29c:	clr	$40
;e29e:	pshh
;e29f:	pulx
;e2a0:	clrh
;e2a1:	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; ???

;e2a2:	lda	$40
;e2a4:	clrh
;e2a5:	div
;e2a6:	sta	$40
;e2a8:	pula
;e2a9:	div
;e2aa:	bra	e29e
;e2ac:	pshx
;e2ad:	ldx	#$08
;e2af:	clra
;e2b0:	pshx
;e2b1:	psha
;e2b2:	tsx
;e2b3:	asl	$04,x
;e2b5:	rol	$40
;e2b7:	rola
;e2b8:	sta	,x
;e2b9:	cmp	$03,x
;e2bb:	bcs	e2d3
;e2bd:	bne	e2c8
;e2bf:	lda	$40
;e2c1:	sub	$02,x
;e2c3:	bcc	e2cc
;e2c5:	lda	,x
;e2c6:	bra	e2d3
;e2c8:	lda	$40
;e2ca:	sub	$02,x
;e2cc:	sta	$40
;e2ce:	lda	,x
;e2cf:	sbc	$03,x
;e2d1:	inc	$04,x
;e2d3:	dbnz	$01,x,e2c3
;e2d6:	sta	,x
;e2d7:	pulh
;e2d8:	ais	#$03
;e2da:	ldx	$40
;e2dc:	pula
;e2dd:	clr	$40
;e2df:	rts

	include usb08

	org $FFF0
;	fcb     E126DFFFDFFFDFFFDFFFDF9DDFFFDC00
;	fdb	_isrKey		; Keyboard Vector
	fdb	_isrDummy
	fdb	_isr_timOF	; TIM Overflow Vector
	fdb	_isrDummy	; TIM Channel 1 Vector
	fdb	_isrDummy	; TIM Channel 0 Vector
	fdb	_isrDummy	; ~IRQ1
	fdb	_isrUSB		; USB Vector
	fdb	_isrDummy	; SWI Vector
	fdb	__start		; Reset Vector

