; include file for usb08.asm

;;;;;;;;;;;;;;;;;;;;;;;;; variables ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	org RamStart
;Setup_Packet  ds      8      ; array for SETUP packet
Setup_Packet   rmb     8
bmReqType      equ    Setup_packet      ; Characteristic of Request
bRequest       equ    Setup_packet+1    ; Request Code
wValueL        equ    Setup_packet+2    ; Low byte Value Field
wValueH        equ    Setup_packet+3    ; High byte Value Field
wIndexL        equ    Setup_packet+4    ; Low byte Index Field
wIndexH        equ    Setup_packet+5    ; High byte Index Field
wLengthL       equ    Setup_packet+6    ; Low byte Length Field
wLengthH       equ    Setup_packet+7    ; High byte Length Field

;USB_State    ds      1         ; Device State Byte
USB_State     rmb     1
POWERED       equ     0         ; USB_State=POWERED
DEFAULT       equ     1         ; USB_State=DEFAULT
ADDRESSED     equ     2         ; USB_State=ADDRESSED
CONFIGURED    equ     3         ; USB_State=CONFIGURED

SET_ADDRESS   equ     5         ; Standard Request code for SET_ADDRESS
GET_DESC      equ     6         ; Standard Request code for GET_DESCRIPTOR
SET_CONFIG    equ     9         ; Standard Request code for SET_CONFIGURATION

; those 6 one should also be ds instead of fdb
addrset       rmb       1       ; bit 7=1 indicates device address has
				; been received, bits 6-0 = address
control       rmb      1        ; type of transfer in progress
descptr       rmb      2        ; pointer to descriptor being sent
descendptr    rmb      2        ; end pointer to descriptor being sent
buffptr       rmb      2        ; index into the USB data buffer
tptr          rmb      2        ; temporary pointer for storage

tmp_1	rmb	16 ; just in case ... the program use more memory than expected:
tmp_3	rmb	16 ; just in case ...
servo_0	rmb	1
servo_1	rmb	1
servo_2	rmb	1
servo_3	rmb	1
servo_4	rmb	1
servo_5	rmb	1
servo_6	rmb	1
servo_7	rmb	1
s0_tmp	rmb	1
s1_tmp	rmb	1
s2_tmp	rmb	1
s3_tmp	rmb	1
s4_tmp	rmb	1
s5_tmp	rmb	1
s6_tmp	rmb	1
s7_tmp	rmb	1
servo_init rmb	1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; constants ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	org $e2e0
Dev_Desc:
	       fcb  DDesc_End-Dev_Desc  ; Descriptor Length
       fcb  $01                  ; Descriptor Type (Device)
       fcb  $10,$01              ; USB specification Release (1.10)
       fcb  $00                  ; Class Code
       fcb  $00                  ; Subclass Code
       fcb  $00                  ; Protocol Code
       fcb  $08                  ; Maximum Packet Size for EP0 (8 bytes)
;	fcb  $05,$f9	; Vendor ID=none ;from pEmicro
;	fcb  $70,$0c	; Vendor ID=none ; from cosmic
	fcb  $70,$0c	; Vendor ID=none
;	fcb  $ff,$ff	; Product ID=none
	fcb  $00,$00	; Product ID=none
       fcb  $00,$01              ; Device Release Number (1.00)
       fcb  $01                  ; Index to Manufacturer String Descriptor
       fcb  $02		; Index to Product String Descriptor
       fcb  $00		; Index to Device Serial Number String Descript or
       fcb  $01		; Number of possible configurations (1)
DDesc_End:

;	fcb	$12,$01,$10,$01,$00,$00,$00,$08,$70,$0C,$00,$00,$00,$01,$01,$02
;	fcb	$00,$01

Con_Desc:
       fcb  CDesc_End-Con_Desc	; Descriptor Length
       fcb  $02			; Descriptor Type (Configuration)
       fcb  E1Desc_End-Con_Desc,$00 ; Total data length (Config-Interface-EP)
       fcb  $01                 ; Interfaces supported
       fcb  $01                 ; Configuration Value
       fcb  $00                 ; Index to String Descriptor
       fcb  $C0                 ; Self powered
       fcb  $FF			; Maximum power consumption=0mA (not applicable)
CDesc_End:
;	fcb	$09,$02,$20,$00,$01,$01,$00,$C0,$00

Int_Desc:
       fcb  IDesc_End-Int_Desc ; Descriptor Length
       fcb  $04                  ; Descriptor Type (Interface)
       fcb  $00                  ; Number of Interface
       fcb  $00                  ; No alternate setting
       fcb  $02                  ; Number of endpoints
;       fcb  $03                  ; Class Code (HID)
       fcb  $ff                  ; Class Code (HID)
       fcb  $01                  ; Subclass Code
       fcb  $ff                  ; Protocol Code
       fcb  $00                  ; Index to String Descriptor
IDesc_End:

;	fcb	$09,$04,$00,$00,$02
;	fcb	$FF,$01,$FF,$00

HID_Desc:
       fcb  HDesc_End-HID_Desc ; Descriptor Length
;       fcb  $21                  ; Descriptor Type (HID)
       fcb  $05                  ; Descriptor Type (HID)
;       fcb  $00,$01              ; HID Class Release (1.00)
       fcb  $81,$03              ; HID Class Release (1.00)
       fcb  $08                  ; Country Code=$00
       fcb  $00                  ; number of HID class descriptors
;       fcb  $22                  ; Class Descriptor Type (REPORT)
       fcb  $0A                  ; Class Descriptor Type (REPORT)
;       fcb  RDesc_End-Rep_Desc,$00 ; length of report descriptor
HDesc_End:
;fcb	$07,$05,$81,$03,$08,$00,$0A
; missing RDesc_End-Rep_Desc,$00 ; length of report descriptor ???

Endp1_Desc:
       fcb  E1Desc_End-Endp1_Desc ; Descriptor Length
       fcb  $05                  ; Descriptor Type (Endpoint)
;       fcb  $81                  ; Endpoint Address and Direction (#1,IN)
       fcb  $02                  ; Endpoint Address and Direction (#1,IN)
       fcb  $03                  ; Endpoint Attribute (Interrupt)
;       fcb  $01,$00              ; Maximum Packet Size for EP1 (1 byte)
       fcb  $08,$00              ; Maximum Packet Size for EP1 (1 byte)
;       fcb  $FF                  ; Polling Interval=255[ms]
       fcb  $0A                  ; Polling Interval=255[ms]
E1Desc_End:
;	fcb	$07,$05,$02,$03,$08,$00,$0A

Rep_Desc:
;       fcb  $06,$00,$FF          ; Usage Page (vendor defined)
;       fcb  $09,$01              ; Usage (vendor defined)

;       fcb  $A1,$01              ; Collection (Application)
;       fcb  $09,$02              ; Usage (vendor defined)
; Input report
;       fcb  $09,$03              ; Usage (vendor defined)
;       fcb  $15,$00              ; Logical Minimum ($00)
;       fcb  $26,$FF,$00          ; Logical Maximum ($FF)
;       fcb  $75,$08              ; Report Size (8 bits)
;       fcb  $95,$01              ; Report Count (1 field)
;       fcb  $81,$02              ; Input (Data, Variable, Absolute)
;       fcb  $C0                  ; End Collection
RDesc_End:

;	org	0xE312
	fcb	$04,$03,$09,$04

;	org	0xE316
;	Vendor
	fcb	$28,$03,'D',$00,'E',$00,'M',$00,'A',$00,'I',$00,'N',$00,'E',$00
	fcb	' ',$00,'B',$00,'e',$00,'n',$00,'o',$00,'i',$00,'t',$00,'-',$00
	fcb	'P',$00,'.',$00,' ',$00,' ',$00

;	Product
	fcb	$2E,$03,'U',$00,'S',$00,'B',$00,' ',$00,'S',$00,'e',$00,'r',$00
	fcb	'v',$00,'o',$00,' ',$00,'a',$00,'d',$00,'a',$00,'p',$00,'t',$00
	fcb	'o',$00,'r',$00,'.',$00,' ',$00,' ',$00,' ',$00,' ',$00

	fcb	$E3,$12,$E3,$16,$E3,$3E

